<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

function smp_access_check() {
    if (config_item('login_required') == "1") {
        $CI =& get_instance();
        if ($CI->session->userdata('user_id') == '') {
            redirect("/action/showlogin", 'refresh');
        }
        if ($CI->session->userdata('role_id') <> 1){
            if (config_item('site_id') != $CI->session->userdata('site_id')) {
                redirect("/action/showlogin", 'refresh');
            }
        }
    }
} //end function

function smp_validate_site() {
    $CI =& get_instance();
    if ($CI->session->userdata('user_id') == ''){
        redirect("/action/showlogin", 'refresh');
    }
    if ($CI->session->userdata('role_id') <> 1){
        if (config_item('site_id') != $CI->session->userdata('site_id')) {
            redirect("/action/showlogin", 'refresh');
        }
    }
} //end function

//---------------------------------------------------------------

/**
 * Function: smp_get_page_perm_array
 * Description: Checks if logged in user has page access
 * ##############################################################
 * Written: 02/07/2010
 * Author: Deep Arora
 * --------------------------------------------------------------
 * Update Log:
 * --------------------------------------------------------------
 * ##############################################################
 * @access public
 * @return void
 */
function smp_get_page_perm_array() {
    $perm_array[] = "";
     /* -----------------------------------------------------
     * Permission array has the following structure:
     * -----------------------------------------------------
     * 1,3,5,7,9,11 -> view, add, edit, delete, self, others
     * 2,4,6,8,10,12 -> permission values.
     * -----------------------------------------------------
     * Permission value is set to 1 if user has access
     * Permission value is set to 0 if user has no access
     */

    $CI =& get_instance();
    if ($CI->session->userdata('user_id') == '') {
        redirect("/global/action/", 'refresh');
    }
    $uri_string = explode("/", uri_string());
    $CI->load->model($CI->config->item('perm_model'));
    $perm_array = $CI->Perm_model->get_permission($uri_string[1], $uri_string[2]);
    return $perm_array;

} //end function

//---------------------------------------------------------------

/**
 * Function: smp_check_permission
 * Description: Checks if logged in user has action access
 * ##############################################################
 * Written: 02/07/2010
 * Author: Deep Arora
 * --------------------------------------------------------------
 * Update Log:
 * --------------------------------------------------------------
 * ##############################################################
 * @access public
 * @return void
 */
function smp_check_permission($action = '', $return = '') {
    $CI =& get_instance();
    if ($CI->session->userdata('user_id') == '' || $CI->session->userdata('role_id') == '') {
        redirect("/global/action/", 'refresh');
    }
    if ($action){
        $uri_string = explode("/", uri_string());
        $CI->load->model($CI->config->item('perm_model'));
        $permission = $CI->Perm_model->get_permission($uri_string[1], $uri_string[2], $action);
        if ($permission){
            return $permission;
        }
        else{
            if ($return){
                return 0;
            }
            else{
                $noaccess_path = site_url('global/action/noaccess');
                header('Location: ' . $noaccess_path);
                //redirect("/global/action/noaccess", 'refresh');
            }
        }
    }
    else{
        return 0;
    }



} //end function

/**
 * Function: smp_check_permission
 * Description: Checks if logged in user has action access
 * ##############################################################
 * Written: 02/07/2010
 * Author: Deep Arora
 * --------------------------------------------------------------
 * Update Log:
 * --------------------------------------------------------------
 * ##############################################################
 * @access public
 * @return void
 */
function smp_action_permission($action = '') {
    $CI =& get_instance();
    if ($CI->session->userdata('user_id') == '') {
        redirect("/global/action/", 'refresh');
    }
    if ($action){
        switch($action) {
            case "Save":
                return smp_check_permission($CI->config->item('perm_edit'));
            break;
            case "Submit":
                return smp_check_permission($CI->config->item('perm_add'));
            break;
            case "Delete":
                return smp_check_permission($CI->config->item('perm_delete'));
            break;
        }
    }
    else{
        return 0;
    }



} //end function

/**
 * Function: smp_check_session
 * Description: Checks if user is logged in
 * ##############################################################
 * Written: 02/07/2010
 * Author: Deep Arora
 * --------------------------------------------------------------
 * Update Log:
 * --------------------------------------------------------------
 * ##############################################################
 * @access public
 * @return void
 */
function smp_check_session() {
    $CI =& get_instance();
    if ($CI->session->userdata('user_id') == '') {
        return false;
    }
    else{
        $user_id = smp_lookup('user_id', $CI->config->item('tbl_users'), 'user_id = ' . $CI->session->userdata('user_id'));
        if ($user_id > 0)
            return true;
        else
            return false;
    }
} //end function

/**
 * Function: set_admin_theme
 * Description: Sets the admin panel theme
 * ##############################################################
 * Written: 01/14/2010
 * Author: Deep Arora
 * --------------------------------------------------------------
 * Update Log:
 * --------------------------------------------------------------
 * ##############################################################
 * @access public
 * @return void
 */
function smp_set_admin_theme() {
    $CI =& get_instance();
    $CI->template->set_theme('default/');
} //end function


//---------------------------------------------------------------

/**
 * Function: set_pagination
 * Description: Sets the pagination links
 * ##############################################################
 * Written: 01/14/2010
 * Author: Deep Arora
 * --------------------------------------------------------------
 * Update Log:
 * --------------------------------------------------------------
 * ##############################################################
 * @access public
 * @return pagination links
 */
function smp_set_pagination($page_name, $total_records, $uri_segment = 4) {
    if ($page_name && $total_records) {
        $CI =& get_instance();
        $config['base_url'] = config_item('base_url') . config_item('index_page') . $page_name;
        $config['total_rows'] = $total_records;
        $config['uri_segment'] = $uri_segment;

        $config['full_tag_open'] = '<div id=pager><ul class=pagination>';
        $config['full_tag_close'] = '</ul></div>';
        $config['num_tag_open'] = '<li>';
        $config['num_tag_close'] = '</li>';
        $config['cur_tag_open'] = '<li class=active>';
        $config['cur_tag_close'] = '</li>';
        $config['last_tag_open'] = '<li class=next>';
        $config['last_tag_close'] = '</li>';
        $config['next_link'] = 'Next';
        $config['next_tag_open'] = '<li class=next>';
        $config['next_tag_close'] = '</li>';
        $config['first_link'] = 'First';
        $config['first_tag_open'] = '<li class=next>';
        $config['first_tag_close'] = '</li>';
        $config['prev_link'] = 'Prev';
        $config['prev_tag_open'] = '<li class=next>';
        $config['prev_tag_close'] = '</li>';

        $config['per_page'] = config_item('records_per_page');

        $CI->pagination->initialize($config);
        return $CI->pagination->create_links();
    }
    return null;
}

//---------------------------------------------------------------

/**
 * Function: set_admin_theme
 * Description: Sets the admin panel theme
 * ##############################################################
 * Written: 01/14/2010
 * Author: Deep Arora
 * --------------------------------------------------------------
 * Update Log:
 * --------------------------------------------------------------
 * ##############################################################
 * @access public
 * @return void
 */
function smp_get_search_form($search_fields, $form_action) {
    $CI =& get_instance();
    $CI->form // then we fill the form with elements
    ->open($form_action);

    foreach ($search_fields as $value) {
        $search_field = explode("|", $value);

        switch($search_field[2]) {
            case "text":
                $CI->form->text($search_field[0], $search_field[1], 'trim|alpha_numeric|max_length[255]|xss_clean');
            break;
            case "textarea":
                $CI->form->textarea($search_field[0], $search_field[1], 'trim|xss_clean');
            break;

            default:
            break;
        }
    }
    $CI->form->indent(200);
    $CI->form->submit();
    $CI->form->reset();
    $CI->form->onsuccess('redirect', $form_action);

    $data['search_form'] = $CI->form->get(); // this returns the validated form as a string
    $CI->template->set('form_search', $data['search_form']);
    //$data['errors'] = $this->form->errors;  // this returns validation errors as a string

} //end function

//---------------------------------------------------------------

/**
 * Function: smp_set_page_meta
 * Description: Sets the page title & description
 * ##############################################################
 * Written: 01/25/2010
 * Author: Deep Arora
 * --------------------------------------------------------------
 * Update Log:
 * --------------------------------------------------------------
 * ##############################################################
 * @access public
 * @return void
 */
function smp_set_page_meta($module_name = '', $meta_name = '', $page_button_set = '') {

    $CI =& get_instance();
    $CI->load->model($CI->config->item('meta_model'));
    $page_meta = $CI->Meta_model->get_page_meta($meta_name);

    if (empty($page_meta)) {
        $CI->template->set('page_title', $CI->lang->line('default_page_title'));
        $CI->template->set('page_subtitle', $CI->lang->line('default_page_subtitle'));
        $CI->template->set('page_description', $CI->lang->line('default_page_description'));
        $CI->template->set('page_help', $CI->lang->line('default_page_help'));
    }
    else {
        foreach($page_meta as $record_details){
            switch ($record_details->meta_key) {
                case "page_title":
                    $CI->template->set('page_title', $record_details->meta_value);
                    break;
                case "page_subtitle":
                    $CI->template->set('page_subtitle', $record_details->meta_value);
                    break;
                case "page_description":
                    $CI->template->set('page_description', $record_details->meta_value);
                    break;
                case "page_help":
                    $CI->template->set('page_help', $record_details->meta_value);
                    break;

                default:
                    $CI->template->set('page_title', $CI->lang->line('default_page_title'));
                    $CI->template->set('page_subtitle', $CI->lang->line('default_page_subtitle'));
                    $CI->template->set('page_description', $CI->lang->line('default_page_description'));
                    $CI->template->set('page_help', $CI->lang->line('default_page_help'));
                    break;
            }
        }
    }

    $active_cptheme = smp_lookup('active_theme', $CI->config->item('tbl_users'), 'user_id = ' . $CI->session->userdata('user_id'));
    if ($active_cptheme == ""){
        $active_cptheme = smp_lookup('key_value', $CI->config->item('tbl_config'), 'key_name = \'DEFAULT_CPTHEME\'');
    }

    $CI->template->set('active_cptheme', $active_cptheme);

    $theme_options = get_dropdown($CI->config->item('tbl_config'), 'key_value', 'key_title', 'key_name = \'CP_THEMES\'', $active_cptheme, site_url("global/action/switchtheme"), '');
    $CI->template->set('theme_options', $theme_options);

    $page_buttons = "";
    if(is_array($page_button_set) && $page_button_set){
        foreach($page_button_set as $key => $value){
            $button_code = "<button id='record' class='ui-button float-right ui-state-default ui-corner-all'>". $key ."</button>";
            $page_buttons = $page_buttons . anchor($module_name . '/' . $value, $button_code);
        }
    }

    $CI->template->set('page_buttons', $page_buttons);
    $menu_code = smp_get_app_menu();
    $CI->template->set('menu_code', $menu_code);
    smp_version_check();
}

//---------------------------------------------------------------

/**
 * Function: smp_form_where_clause
 * Description: Creates the additional where clause for queries
 * ##############################################################
 * Written: 01/14/2010
 * Author: Deep Arora
 * --------------------------------------------------------------
 * Update Log:
 * --------------------------------------------------------------
 * ##############################################################
 * @access public
 * @return void
 */
function smp_form_where_clause($field_array = '', $table_name = '') {
    $where_additional = "";
    $iCounter = 0;
    $CI =& get_instance();

    unset($field_array['action']);

    foreach ($field_array as $key=>$value) {
        if ($value){
            $iCounter = $iCounter + 1;
            $CI->form_validation->set_rules($key, $key, 'trim|xss_clean');
            if ($CI->form_validation->run() == TRUE)
            {
                if ($iCounter > 1)
                    $where_additional = $where_additional . " AND ";

                if(is_numeric($value)){
                    $where_additional = $where_additional . $table_name . "." . $key . " = " . $value;
                }
                else{
                    $where_additional = $where_additional . $table_name . "." . $key . " LIKE '%" . trim($value) . "%'";
                }
            }
        }
    }
    return $where_additional;
} //end function

/**
 * Function: smp_get_app_menu
 * Description: Creates the application menu
 * ##############################################################
 * Written: 01/26/2010
 * Author: Deep Arora
 * --------------------------------------------------------------
 * Update Log:
 * --------------------------------------------------------------
 * ##############################################################
 * @access public
 * @return void
 */
function smp_get_app_menu(){
    $menu_code = "";
    $CI =& get_instance();
    $CI->load->model($CI->config->item('perm_model'));
    $perm_module_meta = $CI->Perm_model->get_modules();

    if (!empty($perm_module_meta)){
        $menu_code = $menu_code . " <ul id='navigation'> ";
        foreach($perm_module_meta as $record_module_details){
            $menu_code = $menu_code .  " <li> " ;
            if ($record_module_details->folder_name){
                $menu_code = $menu_code .  anchor($record_module_details->folder_name . "/" . $record_module_details->file_name, $record_module_details->title);
            }
            else {
                $menu_code = $menu_code .  "<a href='#'>" . $record_module_details->title . "</a>";
            }
            $perm_submodule_meta = $CI->Perm_model->get_submodules($record_module_details->module_id);
            if (!empty($perm_submodule_meta)){
                $menu_code = $menu_code .  " <ul> ";
                foreach($perm_submodule_meta as $record_submodule_details){
                    if ($record_submodule_details->folder_name){
                        $menu_code = $menu_code .  " <li> " . anchor($record_submodule_details->folder_name . "/" . $record_submodule_details->file_name, $record_submodule_details->title) . "   </li> ";
                    }
                    else {
                        $menu_code = $menu_code .  " <li> <a href='#'> " . $record_submodule_details->title . " </a></li> ";
                    }
                }
                $menu_code = $menu_code .  " </ul> ";
            }
            $menu_code = $menu_code .  " </li> " ;
        }
        $menu_code = $menu_code .  " </ul> ";
    }
    return $menu_code;
}

/**
 * Function: smp_version_check
 * Description: Checks SMP Version
 * ##############################################################
 * Written: 01/26/2010
 * Author: Deep Arora
 * --------------------------------------------------------------
 * Update Log:
 * --------------------------------------------------------------
 * ##############################################################
 * @access public
 * @return void
 */
function smp_version_check($forced_check = false){
    $CI =& get_instance();
    $flg_license = smp_lookup('key_value', $CI->config->item('tbl_config'), 'key_name = \'LICENSE\'');
    if($flg_license < 1){
        $notification_url = $CI->config->item('smp_version_url');
        $handle = @fopen($notification_url,'r');
        if($handle !== false){
            $app_location = $_SERVER['SERVER_NAME'];
            $notification_url = $notification_url . $app_location;
            $get_version = file_get_contents($notification_url);
            //echo $get_version;
            $sql = "UPDATE global_config SET key_value = 1 WHERE key_name = 'LICENSE' LIMIT 1";
            smp_execute($sql);
        }
    }
    if($forced_check == true){
        $notification_url = $CI->config->item('smp_version_url');
        $handle = @fopen($notification_url,'r');
        if($handle !== false){
            $notification_url = $notification_url;
            $get_version = file_get_contents($notification_url);
            return $get_version;
        }
    }
}

/**
 * Function: smp_create_form
 * Description: Creates the form
 * ##############################################################
 * Written: 01/25/2010
 * Author: Deep Arora
 * --------------------------------------------------------------
 * Update Log:
 * Usage Instructions:
 *  $links_form_fields = array(
        array(
             'field'    =>  'title',
             'label'    =>  'Title',
             'type'     =>  'text',
             'class'    =>  'small',
             'value'    =>  'value here'
          ),
        array(
             'field'    =>  'redirect_to',
             'label'    =>  'Desitnation URL',
             'type'     =>  'dropdown',
             'class'    =>  'medium',
             'value'    =>  $options
        )
     );
 *
 *   For dropdown values, form an array and pass. Example:
 *   $options = array(
        'small'  => 'Small Shirt',
        'med'    => 'Medium Shirt',
        'large'   => 'Large Shirt',
        'xlarge' => 'Extra Large Shirt'
     );
 * --------------------------------------------------------------
 * ##############################################################
 * @access public
 * @return void
 */
function smp_create_form($form_fields = '', $form_action = '', $form_name = '', $form_perm = 'perm_submit', $design = 'plain') {
    $smp_form = "";
    $custom = "";

    switch($design) {
        case "tabs":
            $smp_form = "<div id='tabs'>";
            $smp_form .= "<ul>";
            $smp_form .= "    <li><a href=\"#First\">First</a></li>";
            $smp_form .= "    <li><a href=\"#Second\">Second</a></li>";
            $smp_form .= "    <li><a href=\"#Third\">Third</a></li>";
            $smp_form .= "</ul>    ";
        break;

        default:
            $smp_form = "<div>";
        break;
    }
    $CI =& get_instance();
    if ($form_fields && $form_action && $form_name) {

        $form_attributes = array('name' => $form_name, 'id' => $form_name);
        $smp_form = $smp_form . form_open($form_action, $form_attributes);
        $smp_form = $smp_form . "<ul>";

        for ($row = 0; $row < sizeof($form_fields); $row++)
        {
            if ($form_fields[$row]['value']): $field_value = $form_fields[$row]['value'];
            else : $field_value = set_value($form_fields[$row]['field']);
            endif;
            //$field_value = $form_fields[$row]['value'];

            switch($form_fields[$row]['type']) {

            case "text":

                if (isset($form_fields[$row]['custom'])){
                    $custom = $form_fields[$row]['custom'];
                }
                if (isset($form_fields[$row]['design'])){
                    $smp_form = $smp_form . "<div id=\"" . $form_fields[$row]['design'] . "\">";
                }
                $smp_form = $smp_form . "<label class='desc'>" . $form_fields[$row]['label'] . "</label>";
                $smp_form = $smp_form . "<div><input type='". $form_fields[$row]['type'] ."' name='". $form_fields[$row]['field'] . "' id='" . $form_fields[$row]['field'] . "' class='" . $form_fields[$row]['class'] . " field text' value='". $field_value ."' " . $custom . "> </div>";
                if (isset($form_fields[$row]['help'])){
                    $smp_form = $smp_form . "<label class='desc'>&nbsp;</label><div class='help'>" . $form_fields[$row]['help'] . "</div><br>";
                }
                if (form_error($form_fields[$row]['field'])){
                    $smp_form = $smp_form . "<label class='desc'>&nbsp;</label><div class='message'>" . form_error($form_fields[$row]['field']) . "</div>";
                }
                if (isset($form_fields[$row]['design'])){
                    $smp_form = $smp_form . "</div>";
                }
                $smp_form = $smp_form . "<br>";
            break;

            case "checkbox":
                $smp_form = $smp_form . "<label class='desc'>" .$form_fields[$row]['label'] . "</label>";
                $smp_form = $smp_form . "<div><input type='". $form_fields[$row]['type'] ."' name='". $form_fields[$row]['field'] . "' id='" . $form_fields[$row]['field'] . "' class='" . $form_fields[$row]['class'] . " field text' $field_value> </div>";
                if (isset($form_fields[$row]['help'])){
                    $smp_form = $smp_form . "<label class='desc'>&nbsp;</label><div class='help'>" . $form_fields[$row]['help'] . "</div>";
                }
                $smp_form = $smp_form . "<br>";
            break;

            case "textarea":
                if (isset($form_fields[$row]['design'])){
                    $smp_form = $smp_form . "<div id=\"" . $form_fields[$row]['design'] . "\">";
                }
                //$smp_form = $smp_form . "<li><label class='desc'>" . $form_fields[$row]['label'] . "</label></li>";
                $smp_form = $smp_form . "<label class='desc'>" . $form_fields[$row]['label'] . "</label>";
                $smp_form = $smp_form . "<div><textarea name='". $form_fields[$row]['field'] . "' id='" . $form_fields[$row]['field'] . "' cols='50' rows='5' class='" . $form_fields[$row]['class'] . " field textarea'>". $field_value ."</textarea> </div>";
                if (isset($form_fields[$row]['help'])){
                    $smp_form = $smp_form . "<label class='desc'>&nbsp;</label><div class='help'>" . $form_fields[$row]['help'] . "</div>";
                }
                if (form_error($form_fields[$row]['field'])){
                    $smp_form = $smp_form . "<label class='desc'>&nbsp;</label><div class='message'>" . form_error($form_fields[$row]['field']) . "</div>";
                }
                if (isset($form_fields[$row]['design'])){
                    $smp_form = $smp_form . "</div>";
                }
                $smp_form = $smp_form . "<br>";
            break;

            case "htmleditor":
                if (isset($form_fields[$row]['design'])){
                    $smp_form = $smp_form . "<div id=\"" . $form_fields[$row]['design'] . "\">";
                }
                $smp_form = $smp_form . "<div class='portlet ui-widget ui-widget-content ui-helper-clearfix ui-corner-all'>";

                //$smp_form = $smp_form . "<li><label class='desc'>" . $form_fields[$row]['label'] . "</label></li>";
                $smp_form = $smp_form . "<div class='portlet-header ui-widget-header'>" . $form_fields[$row]['label'] . "<span class='ui-icon ui-icon-circle-arrow-s'></span></div>";
                //$smp_form = $smp_form . "<div><textarea name='". $form_fields[$row]['field'] . "' id='" . $form_fields[$row]['field'] . "' cols='50' rows='5' class='" . $form_fields[$row]['class'] . " field textarea'>". $field_value ."</textarea> </div>";
                $smp_form = $smp_form . "<div class='portlet-content'>" . form_ckeditor($form_fields[$row]['field'], $field_value, $form_fields[$row]['class'] ) .  "</div>";
                if (isset($form_fields[$row]['help'])){
                    $smp_form = $smp_form . "<label class='desc'>&nbsp;</label><div class='help'>" . $form_fields[$row]['help'] . "</div>";
                }
                if (form_error($form_fields[$row]['field'])){
                    $smp_form = $smp_form . "<label class='desc'>&nbsp;</label><div class='message'>" . form_error($form_fields[$row]['field']) . "</div>";
                }
                if (isset($form_fields[$row]['design'])){
                    $smp_form = $smp_form . "</div>";
                }
                $smp_form = $smp_form . "</div>";
            break;

            case "dropdown":
                if (isset($form_fields[$row]['design'])){
                    $smp_form = $smp_form . "<div id=\"" . $form_fields[$row]['design'] . "\">";
                }
                $smp_form = $smp_form . "<label class='desc'>" . $form_fields[$row]['label'] . "</label>";
                $tmpClass = 'field select ' . $form_fields[$row]['class'];
                if (is_array($field_value)) {
                    $smp_form = $smp_form . "<div>". form_dropdown($form_fields[$row]['field'], $field_value, $form_fields[$row]['selected'], 'class=\'' . $tmpClass . '\'') ."</div>";
                }
                else{
                    if(isset($form_fields[$row]['create_new'])){
                        $smp_form = $smp_form . "<div><a href='". $form_fields[$row]['create_new'] ."'>Click to create new!</a></div><br>";
                    }
                }
                if (form_error($form_fields[$row]['field'])){
                    $smp_form = $smp_form . "<label class='desc'>&nbsp;</label><div class='message'>" . form_error($form_fields[$row]['field']) . "</div>";
                }
                if (isset($form_fields[$row]['help'])){
                    $smp_form = $smp_form . "<label class='desc'>&nbsp;</label><div class='help'>" . $form_fields[$row]['help'] . "</div>";
                }
                if (isset($form_fields[$row]['design'])){
                    $smp_form = $smp_form . "</div>";
                }
                $smp_form = $smp_form . "<br>";
            break;

            case "multiselect":
                if (isset($form_fields[$row]['design'])){
                    $smp_form = $smp_form . "<div id=\"" . $form_fields[$row]['design'] . "\">";
                }
                $smp_form = $smp_form . "<label class='desc'>" . $form_fields[$row]['label'] . "</label>";
                $tmpClass = 'field select ' . $form_fields[$row]['class'];
                if (is_array($field_value)) {
                    $smp_form = $smp_form . "<div>". form_multiselect($form_fields[$row]['field'], $field_value, $form_fields[$row]['selected'], 'class=\'' . $tmpClass . '\'') ."</div>";
                }
                else{
                    if(isset($form_fields[$row]['create_new'])){
                        $smp_form = $smp_form . "<div><a href='". $form_fields[$row]['create_new'] ."'>Click to create new!</a></div><br>";
                    }
                }
                if (form_error($form_fields[$row]['field'])){
                    $smp_form = $smp_form . "<label class='desc'>&nbsp;</label><div class='message'>" . form_error($form_fields[$row]['field']) . "</div>";
                }
                if (isset($form_fields[$row]['help'])){
                    $smp_form = $smp_form . "<label class='desc'>&nbsp;</label><div class='help'>" . $form_fields[$row]['help'] . "</div>";
                }
                if (isset($form_fields[$row]['design'])){
                    $smp_form = $smp_form . "</div>";
                }
                $smp_form = $smp_form . "<br>";
            break;

            case "link":
                $smp_form = $smp_form . "<label class='desc'></label>";
                $smp_form = $smp_form . "<div><a href='". site_url($form_fields[$row]['value']) ."' id='" . $form_fields[$row]['field'] . "' >&raquo; " . $form_fields[$row]['label'] . "</a> </div>";
                if (isset($form_fields[$row]['help'])){
                    $smp_form = $smp_form . "<label class='desc'>&nbsp;</label><div class='help'>" . $form_fields[$row]['help'] . "</div>";
                }
                $smp_form = $smp_form . "<br>";
            break;

            case "hidden":
                $smp_form = $smp_form . "<input type='". $form_fields[$row]['type'] ."' name='". $form_fields[$row]['field'] . "' id='" . $form_fields[$row]['field'] . "' class='" . $form_fields[$row]['class'] . " field text' value='". $field_value ."'>";
            break;

            case "label":
                $smp_form = $smp_form . "<label class='desc'>" . $form_fields[$row]['label'] . "</label>";
                $smp_form = $smp_form . "<div>". $field_value ."</div>";
                $smp_form = $smp_form . "<br>";
            break;

            case "date":
                $smp_form = $smp_form . "<script type='text/javascript'>";
                $smp_form = $smp_form . "$(function() {";
                $smp_form = $smp_form . "        $('#". $form_fields[$row]['field'] ."').datepicker({";
                $smp_form = $smp_form . "        changeMonth: true,";
		$smp_form = $smp_form . "        changeYear: true,";
                $smp_form = $smp_form . "        numberOfMonths: 3,";
                $smp_form = $smp_form . "        dateFormat: 'yy-mm-dd',";
                $smp_form = $smp_form . "        showButtonPanel: true";
                $smp_form = $smp_form . "        });";
                $smp_form = $smp_form . "});";
                $smp_form = $smp_form . "</script>";

                $smp_form = $smp_form . "<label class='desc'>" . $form_fields[$row]['label'] . "</label>";
                $smp_form = $smp_form . "<div tyle='z-index:1; position: relative;'><input type='text' name='". $form_fields[$row]['field'] . "' id='". $form_fields[$row]['field'] . "' class='" . $form_fields[$row]['class'] . " field text' value='". $field_value ."'> </div>";
                if (form_error($form_fields[$row]['field'])){
                    $smp_form = $smp_form . "<label class='desc'>&nbsp;</label><div class='message'>" . form_error($form_fields[$row]['field']) . "</div>";
                }
                if (isset($form_fields[$row]['help'])){
                    $smp_form = $smp_form . "<label class='desc'>&nbsp;</label><div class='help'>" . $form_fields[$row]['help'] . "</div>";
                }
                $smp_form = $smp_form . "<br>";
            break;

            case "design":
                if ($form_fields[$row]['field'] == "slides" && $field_value == "starts"){
                    $smp_form = $smp_form . "<div class='portlet ui-widget ui-widget-content ui-helper-clearfix ui-corner-all'>";
                    $smp_form = $smp_form . "<div class='portlet-header ui-widget-header'>" . $form_fields[$row]['label'] . "<span class='ui-icon ui-icon-circle-arrow-s'></span></div>";
                    $smp_form = $smp_form . "<div class='portlet-content'>";
                }
                if ($form_fields[$row]['field'] == "slides" && $field_value == "ends"){
                    $smp_form = $smp_form . "</div></div>";
                }

            break;

            default:
            break;
            }

        }

        switch($form_perm) {
            case "perm_edit":
                $smp_form = $smp_form . "<li class='buttons'><input type='submit' value='Save' name='action' class='ui-state-default float-right ui-corner-all ui-button'></li>";
                $smp_form = $smp_form . "<li class='buttons'><input type='submit' value='Submit' name='action' class='ui-state-default float-right ui-corner-all ui-button'></li>";
            break;
            case "perm_add":
                $smp_form = $smp_form . "<li class='buttons'><input type='submit' value='Submit' name='action' class='ui-state-default float-right ui-corner-all ui-button'></li>";
            break;
            case "perm_submit":
                $smp_form = $smp_form . "<li class='buttons'><input type='submit' value='Submit' name='action' class='ui-state-default float-right ui-corner-all ui-button'></li>";
            break;
            case "perm_save":
                $smp_form = $smp_form . "<li class='buttons'><input type='submit' value='Save' name='action' class='ui-state-default float-right ui-corner-all ui-button'></li>";
            break;
            case "perm_delete":
                $smp_form = $smp_form . "<li class='buttons'><input type='submit' value='Delete' onClick = 'return confirm(\"Are you sure you want to delete this record?\");' name='action' class='ui-state-default float-right ui-corner-all ui-button'>";
                $smp_form = $smp_form . "&nbsp;&nbsp;<input type='submit' value='Save' name='action' class='ui-state-default float-right ui-corner-all ui-button'></li>";
            break;
            case "perm_view":
            case "default":
            break;
        }

        $smp_form = $smp_form . form_close();
        $smp_form = $smp_form . "</ul></div>";
        $CI->template->set($form_name, $smp_form);

    }
    else {
        $CI->template->set($form_name, $CI->lang->line('message_form_not_enabled'));
    }
}

/**
 * Function: smp_process_form
 * Description: Creates the additional where clause for queries
 * ##############################################################
 * Written: 01/14/2010
 * Author: Deep Arora
 * --------------------------------------------------------------
 * Update Log:
 * --------------------------------------------------------------
 * ##############################################################
 * @access public
 * @return void
 */
function smp_process_form($field_array = '', $table_name = '', $where_additional = '', $post_action_path = '') {
    $iCounter = 0;
    $table_fields = "";
    $CI =& get_instance();
    $CI->load->model($CI->config->item('smp_model'));
    $table_action = $CI->input->post('action');
    unset($field_array['action']);

    switch($table_action) {
        case "Save":
            $check_permission = smp_check_permission($CI->config->item('perm_edit'), $return="true");
        break;
        case "Submit":
            $check_permission = smp_check_permission($CI->config->item('perm_add'), $return="true");
        break;
        case "Delete":
            $check_permission = smp_check_permission($CI->config->item('perm_delete'), $return="true");
        break;
        case "default":
        break;
    }


    if ($check_permission){
        if(is_array($field_array) && $table_name && $table_action){
            $action_status = $CI->Smp_model->process_table($field_array, $table_name, $table_action, $where_additional);
        }
        if ($table_action == "Delete" or $table_action == "Submit"){
            //redirect($post_action_path, 'refresh');
            $post_action_path = site_url($post_action_path);
            if ($action_status){
                header('Location: ' . $post_action_path);
            }
        }
    }
    else{
        $CI->template->set('system_message',  $CI->lang->line('message_noaccess'));
    }
} //end function

/**
 * Function: smp_get_rules
 * Description: Get the form rules of the module
 * ##############################################################
 * Written: 02/10/2010
 * Author: Deep Arora
 * --------------------------------------------------------------
 * Update Log:
 * --------------------------------------------------------------
 * ##############################################################
 * @access public
 * @return void
 */
function smp_get_rules($rule_name = '') {
    $CI =& get_instance();
    if ($rule_name) {
        $CI->load->model($CI->config->item('rule_model'));
        $result_set = $CI->Rule_model->get_rules($rule_name);
        //print_r($result_set);
        return $result_set;
    }
    else {
        return null;
    }
}

/**
 * Function: smp_process_table
 * Description: Perform an action on table
 * ##############################################################
 * Written: 05/06/2010
 * Author: Deep Arora
 * --------------------------------------------------------------
 * Update Log:
 * --------------------------------------------------------------
 * ##############################################################
 * @access public
 * @return void
 */
function smp_process_table($field_array = '', $table_name = '', $where_additional = '', $post_action_path = '') {
    $iCounter = 0;
    $table_fields = "";
    $CI =& get_instance();
    $CI->load->model($CI->config->item('smp_model'));
    $table_action = $CI->input->post('action');
    unset($field_array['action']);

    switch($table_action) {
        case "Save":
            $check_permission = smp_check_permission($CI->config->item('perm_edit'), $return="true");
        break;
        case "Submit":
            $check_permission = smp_check_permission($CI->config->item('perm_add'), $return="true");
        break;
        case "Delete":
            $check_permission = smp_check_permission($CI->config->item('perm_delete'), $return="true");
        break;
        case "default":
        break;
    }


    if ($check_permission){
        if(is_array($field_array) && $table_name && $table_action){
            $action_status = $CI->Smp_model->process_table($field_array, $table_name, $table_action, $where_additional);
        }
        if ($table_action == "Delete" or $table_action == "Submit"){
            //redirect($post_action_path, 'refresh');
            $post_action_path = site_url($post_action_path);
            if ($action_status){
                header('Location: ' . $post_action_path);
            }
        }
    }
    else{
        $CI->template->set('system_message',  $CI->lang->line('message_noaccess'));
    }
} //end function

/**
 * Function: smp_lookup
 * Description: Get the field value from table
 * ##############################################################
 * Written: 03/11/2010
 * Author: Deep Arora
 * --------------------------------------------------------------
 * Update Log:
 * --------------------------------------------------------------
 * ##############################################################
 * @access public
 * @return void
 */
function smp_lookup($field_name, $table_name, $where_condition)
{
    $CI =& get_instance();
    $CI->load->model($CI->config->item('smp_model'));
    $field_value = $CI->Smp_model->look_up($field_name, $table_name, $where_condition);
    return $field_value;
}


/**
 * Function: smp_process_data
 * Description: Performs insert, update, or delete
 * ##############################################################
 * Written: 03/11/2010
 * Author: Deep Arora
 * --------------------------------------------------------------
 * Update Log:
 * --------------------------------------------------------------
 * ##############################################################
 * @access public
 * @return void
 */
function smp_process_data($field_array = '', $table_name = '', $where_additional = '', $post_action_path = '', $table_action = '', $perm_check = true) {
    $iCounter = 0;
    $table_fields = "";
    $CI =& get_instance();
    $CI->load->model($CI->config->item('smp_model'));
    //unset($field_array['action']);

    switch($table_action) {
        case "Save":
            $check_permission = smp_check_permission($CI->config->item('perm_edit'), $return="true");
        break;
        case "Submit":
            $check_permission = smp_check_permission($CI->config->item('perm_add'), $return="true");
        break;
        case "Delete":
            $check_permission = smp_check_permission($CI->config->item('perm_delete'), $return="true");
        break;
        case "default":
        break;
    }
    if ($check_permission || $perm_check == false){
        if ($table_action == "Save" || $table_action == "Submit" ){
            if(is_array($field_array) && $table_name){
                $action_status = $CI->Smp_model->process_table($field_array, $table_name, $table_action, $where_additional);
            }
        }
        if ($table_action == "Delete"){
            if($table_name && $where_additional){
                $action_status = $CI->Smp_model->process_table($field_array, $table_name, $table_action, $where_additional);
            }
        }

        if ($table_action == "Delete" or $table_action == "Submit"){
            //redirect($post_action_path, 'refresh');
            $post_action_path = site_url($post_action_path);
            header('Location: ' . $post_action_path);
        }

        if ($post_action_path == ""){
            $post_action_path = $_SERVER['HTTP_REFERER'];
            header('Location: ' . $post_action_path);
        }
        else{
            $post_action_path = site_url($post_action_path);
            header('Location: ' . $post_action_path);
        }
    }
    else{
        $CI->template->set('system_message',  $CI->lang->line('message_noaccess'));
    }
} //end function


/**
 * Function: smp_count
 * Description: Get the records count from table
 * ##############################################################
 * Written: 03/11/2010
 * Author: Deep Arora
 * --------------------------------------------------------------
 * Update Log:
 * --------------------------------------------------------------
 * ##############################################################
 * @access public
 * @return void
 */
function smp_count($table_name, $where_condition = '')
{
    $CI =& get_instance();
    $CI->load->model($CI->config->item('smp_model'));
    $count = $CI->Smp_model->count_records($table_name, $where_condition);
    return $count;
}

/**
 * Function: smp_execute
 * Description: Execute the SQL statement
 * ##############################################################
 * Written: 01/04/2011
 * Author: Deep Arora
 * --------------------------------------------------------------
 * Update Log:
 * --------------------------------------------------------------
 * ##############################################################
 * @access public
 * @return void
 */
function smp_execute($sql = '')
{
    $CI =& get_instance();
    $CI->load->model($CI->config->item('smp_model'));
    $CI->Smp_model->execute_sql($sql);
    return true;
}
/* DATE UTILITY FUNCTIONS --- STARTS */
function smp_datetime() {
    $currdateTime = date("Y-m-d H:m:s")	;
    return $currdateTime;
}

function smp_add_days_to_date($day,$toadd) //input format: d/m/yyyy
{
    $tmp = explode("-",$day);
    $dadate = mktime(0,0,0,$tmp[1],$tmp[2]+($toadd),$tmp[0]);
    return date('Y-m-d',$dadate);
}

function smp_date_diff($dateFormat, $endDate, $beginDate)
{
	$date_parts1=explode($dateFormat, $beginDate);
	$date_parts2=explode($dateFormat, $endDate);
	$start_date=gregoriantojd($date_parts1[1], $date_parts1[2], 	$date_parts1[0]);
	$end_date=gregoriantojd($date_parts2[1], $date_parts2[2], $date_parts2[0]);
	return $end_date - $start_date;
}
/* DATE UTILITY FUNCTIONS --- ENDS */

function smp_log($log_message, $log_type = 'Payment', $log_by = '') {
    $CI =& get_instance();
    //$logFile = $CI->config->item('log_file');
    //$fileHandle = fopen($logFile, "a");
    //fwrite($fileHandle, date("Y-m-d H:i:s") . "\t" . $message . "\r\n");
    //fclose($fileHandle);
    if($log_by == '' && $CI->session->userdata('user_id') <> ''){
        $log_by = smp_lookup('email', $CI->config->item('tbl_users'), 'user_id = ' . $CI->session->userdata('user_id'));
    }
    $CI->load->model($CI->config->item('smp_model'));
    $CI->Smp_model->log_action($log_message, $log_type, $log_by);
}

/**
 * Function: get_options
 * Description: Get options dropdown
 * ##############################################################
 * Written: 04/12/2010
 * Author: Deep Arora
 * --------------------------------------------------------------
 * Update Log:
 * --------------------------------------------------------------
 * ##############################################################
 * @access public
 * @return void
 */
function get_options($table_name, $field_key, $field_value, $where_condition = '', $default_value_none = true) {
    $CI =& get_instance();
    $CI->load->model($CI->config->item('smp_model'));
    $options = $CI->Smp_model->get_options($table_name, $field_key, $field_value, $where_condition, $default_value_none);
    return $options;
}

/**
 * Function: get_dropdown
 * Description: Get options dropdown
 * ##############################################################
 * Written: 08/23/2010
 * Author: Deep Arora
 * --------------------------------------------------------------
 * Update Log:
 * --------------------------------------------------------------
 * ##############################################################
 * @access public
 * @return void
 */
function get_dropdown($table_name, $field_key, $field_value, $where_condition = '', $selected_value = '', $change_action = '', $post_action_path = '') {
    $CI =& get_instance();
    $CI->load->model($CI->config->item('smp_model'));
    $options = $CI->Smp_model->get_options($table_name, $field_key, $field_value, $where_condition);
    $dropdown = "<form name=\'dropdown\'>";
    $dropdown .= form_dropdown('dropdown', $options, $selected_value, 'onchange = switchvalue(this.form.dropdown)');
    $dropdown .= "<script language=javascript>";
    $dropdown .= "function switchvalue(dropdown){";
    $dropdown .= "var ddindex  = dropdown.selectedIndex;";
    $dropdown .= "var selvalue = dropdown.options[ddindex].value;";
    $dropdown .= "var change_action = \"". $change_action . "\";";
    $dropdown .= "var post_action_path = \"". $post_action_path . "\";";
    $dropdown .= "var seperator = '/';";
    $dropdown .= "var action_url = change_action + seperator + selvalue + seperator + post_action_path;";
    $dropdown .= "location.href = action_url;";
    $dropdown .= "}";
    $dropdown .= "</script>";
    $dropdown .= "</form>";
    return $dropdown;
}

/**
 * Function: smp_convert
 * Description: Encrypt or Decrypt a String
 * ##############################################################
 * Written:
 * Author: Halojoy, July 2006
 * Modified and commented by: Laserlight, August 2006
 * Modified for SMP by: Deep Arora, Jun 2010
 * --------------------------------------------------------------
 * Update Log:
 * --------------------------------------------------------------
 * ##############################################################
 * @access public
 * @return void
 */

function smp_convert($text) {
    $CI =& get_instance();
    // set key to a default value if the key is blank

    if ($CI->config->item('encryption_key') == '') {
        $key = "JAHSGTY651BB819KAJSHBAHST";
    }
    else {
        $key = $CI->config->item('encryption_key');
    }

    // remove the spaces in the key
    $key = str_replace(' ', '', $key);
    if (strlen($key) < 8) {
        exit('key error');
    }
    // set key length to be no more than 32 characters
    $key_len = strlen($key);
    if ($key_len > 32) {
        $key_len = 32;
    }

    $k = array(); // key array
    // fill key array with the bitwise AND of the ith key character and 0x1F
    for ($i = 0; $i < $key_len; ++$i) {
        $k[$i] = ord($key{$i}) & 0x1F;
    }

    // perform encryption/decryption
    for ($i = 0, $j = 0; $i < strlen($text); ++$i) {
        $e = ord($text{$i});
        // if the bitwise AND of this character and 0xE0 is non-zero
        // set this character to the bitwise XOR of itself and the jth key element
        // else leave this character alone
        if ($e & 0xE0) {
            $text{$i} = chr($e ^ $k[$j]);
        }
        // increment j, but ensure that it does not exceed key_len-1
        $j = ($j + 1) % $key_len;
    }
    
    return $text;
}

function smp_encode($string) {
    $data = base64_encode($string);
    $data = str_replace(array('+','/','='),array('-','_',''),$data);
    return $data;
}

function smp_decode($string) {
    $data = str_replace(array('-','_'),array('+','/'),$string);
    $mod4 = strlen($data) % 4;
    if ($mod4) {
        $data .= substr('====', $mod4);
    }
    return base64_decode($data);
}

function smp_encrypt($text){
    $CI =& get_instance();
    $CI->load->library('encrypt');
    return $CI->encrypt->encode($text);
}

function smp_decrypt($text){
    $CI =& get_instance();
    $CI->load->library('encrypt');
    return $CI->encrypt->decode($text);
}

function smp_trimtext($text, $chars = 50) {

        $text = $text." ";
        $text = substr($text,0,$chars);
        //$text = substr($text,0,strrpos($text,' '));
        $text = $text."..";
        
}

function smp_cat_tree($table_name, $child_field, $parent_field, $title_field, $link_field = '', $link_path = '', $where_additional = '')
{
    $CI =& get_instance();
    $CI->load->model($CI->config->item('smp_model'));
    $category_tree = $CI->Smp_model->get_cat_tree($table_name, $child_field, $parent_field, $title_field, $link_field, $link_path, $where_additional);
    if ($category_tree == "") {
        $category_tree = "No records found";
    }
    return $category_tree;
}

function smp_category_tree($parent_id = 0, $escape = 0, $spacing = '', $tree = '', $where = '')
{
    $CI =& get_instance();
    $CI->load->model($CI->config->item('smp_model'));
    $category_tree = $CI->Smp_model->get_category_tree($parent_id, $escape, $spacing, $tree, $where);
    if ($category_tree == "") {
        $category_tree = "No records found";
    }
    return $category_tree;
}

function smp_getfrompost($parameter_name, $default_value = "")
{
    return isset($_POST[$parameter_name]) ? smp_strip($_POST[$parameter_name]) : $default_value;
}

function smp_getfromget($parameter_name, $default_value = "")
{
    return isset($_GET[$parameter_name]) ? smp_strip($_GET[$parameter_name]) : $default_value;
}

function smp_strip($value)
{
  if(get_magic_quotes_gpc() != 0)
  {
    if(is_array($value))
      foreach($value as $key=>$val)
        $value[$key] = stripslashes($val);
    else
      $value = stripslashes($value);
  }
  return $value;
}

function smp_getquerystring($CollectionName, $RemoveParameters)
{
    $querystring = "";
    $postdata = "";
    if($CollectionName == "Form")
        $querystring = smp_collectiontostring($_POST, $RemoveParameters);
    else if($CollectionName == "QueryString")
        $querystring = smp_collectiontostring($_GET, $RemoveParameters);
    else if($CollectionName == "All")
    {
        $querystring = smp_collectiontostring($_GET, $RemoveParameters);
        $postdata = smp_collectiontostring($_POST, $RemoveParameters);
        if(strlen($postdata) > 0 && strlen($querystring) > 0)
            $querystring .= "&" . $postdata;
        else
            $querystring .= $postdata;
    }
    else
        die("1050: Common Functions. EES_GetQueryString Function. " .
            "The CollectionName contains an illegal value.");
    return $querystring;
}

function smp_collectiontostring($ParametersCollection, $RemoveParameters)
{
  $Result = "";
  if(is_array($ParametersCollection))
  {
    reset($ParametersCollection);
    foreach($ParametersCollection as $ItemName => $ItemValues)
    {
      $Remove = false;
      if(is_array($RemoveParameters))
      {
        foreach($RemoveParameters as $key => $val)
        {
          if($val == $ItemName)
          {
            $Remove = true;
            break;
          }
        }
      }
      if(!$Remove)
      {
        if(is_array($ItemValues))
          for($J = 0; $J < sizeof($ItemValues); $J++)
            $Result .= "&" . urlencode(smp_strip($ItemName)) . "[]=" . urlencode(smp_strip($ItemValues[$J]));
        else
           $Result .= "&" . urlencode(smp_strip($ItemName)) . "=" . urlencode(smp_strip($ItemValues));
      }
    }
  }

  if(strlen($Result) > 0)
    $Result = substr($Result, 1);
  return $Result;
}

function smp_getrandstring($length)
{
  if($length>0)
  {
  $rand_id="";
   for($i=1; $i<=$length; $i++)
   {
   mt_srand((double)microtime() * 1000000);
   $num = mt_rand(1,26);
   $rand_id .= smp_assignrandvalue($num);
   }
  }
  return $rand_id;
}

function smp_assignrandvalue($num)
{
// accepts 1 - 36
  switch($num)
  {
    case "1":
     $rand_value = "a";
    break;
    case "2":
     $rand_value = "b";
    break;
    case "3":
     $rand_value = "c";
    break;
    case "4":
     $rand_value = "d";
    break;
    case "5":
     $rand_value = "e";
    break;
    case "6":
     $rand_value = "f";
    break;
    case "7":
     $rand_value = "g";
    break;
    case "8":
     $rand_value = "h";
    break;
    case "9":
     $rand_value = "i";
    break;
    case "10":
     $rand_value = "j";
    break;
    case "11":
     $rand_value = "k";
    break;
    case "12":
     $rand_value = "l";
    break;
    case "13":
     $rand_value = "m";
    break;
    case "14":
     $rand_value = "n";
    break;
    case "15":
     $rand_value = "o";
    break;
    case "16":
     $rand_value = "p";
    break;
    case "17":
     $rand_value = "q";
    break;
    case "18":
     $rand_value = "r";
    break;
    case "19":
     $rand_value = "s";
    break;
    case "20":
     $rand_value = "t";
    break;
    case "21":
     $rand_value = "u";
    break;
    case "22":
     $rand_value = "v";
    break;
    case "23":
     $rand_value = "w";
    break;
    case "24":
     $rand_value = "x";
    break;
    case "25":
     $rand_value = "y";
    break;
    case "26":
     $rand_value = "z";
    break;
    case "27":
     $rand_value = "0";
    break;
    case "28":
     $rand_value = "1";
    break;
    case "29":
     $rand_value = "2";
    break;
    case "30":
     $rand_value = "3";
    break;
    case "31":
     $rand_value = "4";
    break;
    case "32":
     $rand_value = "5";
    break;
    case "33":
     $rand_value = "6";
    break;
    case "34":
     $rand_value = "7";
    break;
    case "35":
     $rand_value = "8";
    break;
    case "36":
     $rand_value = "9";
    break;
  }
  return $rand_value;
}

function smp_sendmail($data)
{
    $CI =& get_instance();
    $CI->load->library('email');
    $config['mailtype'] = 'html';
    $config['protocol'] = 'sendmail';
    $CI->email->initialize($config);
    
    $CI->email->from($data['from'], $data['name']);
    $CI->email->to($data['to']);

    if(isset ($data['cc']))
        $CI->email->cc($data['cc']);

    if(isset ($data['bcc']))
        $CI->email->bcc($data['bcc']);

    $CI->email->subject($data['subject']);
    $CI->email->message($data['message']);

    $CI->email->send();
    $CI->email->clear();
}

/* CRON FUNCTIONS */
function smp_cron_subscriptions()
{
    $CI =& get_instance();
    $CI->load->model($CI->config->item('smp_model'));
    $rs_transactions = $CI->Smp_model->get_pending_subscriptions();
    foreach($rs_transactions as $row)
    {
        $plugin_name = $row->controller;
        $CI->load->plugin($plugin_name);
        $plugin_name($row);
    }
}

function smp_getIp() {
    $ip = $_SERVER['REMOTE_ADDR'];

    if (!empty($_SERVER['HTTP_CLIENT_IP'])) {
        $ip = $_SERVER['HTTP_CLIENT_IP'];
    } elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR'])) {
        $ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
    }

    return $ip;
}




function smp_hook($hook, $data) {
    $CI =& get_instance();
    $CI->load->model($CI->config->item('smp_model'));
    $rs_hooks = $CI->Smp_model->get_hooks($hook);
    foreach($rs_hooks as $row)
    {
        //echo "hook:" . $row->action_type;
        switch($row->action_type) {
            case "helper":
                //$helper_file = $row->action_file;
                //$helper_function = $row->action_function;
                //$CI->load->helper($helper_file);
                //$data = $helper_function($data);
            break;

            case "library":
                $library_folder = $row->action_folder;
                $library_file = $row->action_file;
                $library_function = $row->action_function;

                $CI->load->library($library_folder .DS. $library_file);
                $data = $CI->$library_file->$library_function($data);
            break;

            case "hook":
            break;

            case "module":
                //$module_folder = $row->action_folder;
                //$module_file = $row->action_file;
                //$module_function = $row->action_function;
                //$CI->load->module($module_folder);
                //$data = Modules::run($module_folder .DS. $module_file . DS . $module_function, $data);
            break;

            default:
            break;
        }
    }
    return $data;
}

function smp_logout()
{
    $CI =& get_instance();
    $user_data = array
    (
    'user_id' => '',
    'user_name' => '',
    'role_id' => '',
    'first_name' => '',
    'last_name' => '',
    'email' => '',
    'doj' => '',
    'logged_in' => FALSE
    );
    $CI->session->unset_userdata($user_data);
    $login_page = site_url("global/action");
    header('Location: ' . $login_page);
}

?>