<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Clickbank extends Controller {

    function __construct() {
            parent::Controller();
            $this->load->library('clickbank_lib');
    }

    function process($product_id, $gateway_id)
    {
        if (!smp_check_session() || !$product_id || !$gateway_id){
            $product_id = smp_encode($product_id);
            $getP = site_url('socket/shop/getP/' . $product_id);
            header('Location: ' . $getP);
        }
        else {
            $this->_clickbank_form($product_id, $gateway_id);
            }
    }
    

    function _clickbank_form($product_id, $gateway_id){
        $email = smp_lookup('email', $this->config->item('tbl_users'), 'user_id = ' . $this->session->userdata('user_id'));

        $cb_vendor_id = smp_lookup('setting_1', $this->config->item('tbl_gateways'), 'gateway_id = ' . $gateway_id);
        $item_name = smp_lookup('product_name', $this->config->item('tbl_products'), 'product_id = ' . $product_id);
        $return = smp_lookup('return_url', $this->config->item('tbl_products'), 'product_id = ' . $product_id);
        $cancel_return = smp_lookup('cancel_url', $this->config->item('tbl_products'), 'product_id = ' . $product_id);
        $item_cbid = smp_lookup('cb_id', $this->config->item('tbl_products'), 'product_id = ' . $product_id);
        $item_number = smp_lookup('sku', $this->config->item('tbl_products'), 'product_id = ' . $product_id);
        if ($item_number == "") { $item_number = $product_id; }

        $amount = smp_lookup('price', $this->config->item('tbl_products'), 'product_id = ' . $product_id);
        $currency_code = smp_lookup('currency_code', $this->config->item('tbl_products'), 'product_id = ' . $product_id);
        $custom = $this->session->userdata('user_id');

        $payment_form = "<html>";
        $payment_form .= "<head><title>Processing Payment...</title></head>";
        $payment_form .= "<body onLoad='document.forms['cb_auto_form'].submit();'><br><br>";
        $payment_form .= "<form name='cb_auto_form' method='post' action='http://". $item_cbid . "." . $cb_vendor_id .".pay.clickbank.net?smpuid=". $custom ."&smppid=". $product_id ."&smpgid=". $gateway_id ."'>";
        $payment_form .= "<center>";
        $payment_form .= "<input type='submit' value='click here if you are not redirected in 5 seconds'>";
        $payment_form .= "</form>";
        $payment_form .= "<script> document.forms['cb_auto_form'].submit();</script>";
        $payment_form .= "</center></body></html>";
        echo $payment_form;
    }

    function ipn()
    {
        // all variables sent by Paypal are in the ipn_data() array.
        //smp_log("Checking IPN Now....");
        if ($this->clickbank_lib->validate_ipn())
        {
            //smp_log("CBIPN VERIFIED DUDE....");
            $productId = $this->clickbank_lib->ipn_data['product_id'];
            $order['product_id'] = $productId;
            //smp_log("Product ID:" . $productId);
            $order['productIdInDB'] = smp_lookUp("product_id", $this->config->item('tbl_product_gateways'), "product_id = " . $productId);
            $order['user_id'] = $this->clickbank_lib->ipn_data['user_id'];
            $order['user_name'] = smp_lookUp("username", $this->config->item('tbl_users'), "user_id = " . $order['user_id']);
            $order['user_password'] = smp_lookUp("password", $this->config->item('tbl_users'), "user_id = " . $order['user_id']);
            $order['user_email'] = smp_lookUp("email", $this->config->item('tbl_users'), "user_id = " . $order['user_id']);

            /* Verify for fraudulant transactions */
            if (!$channel){
                $channel = "Clickbank";
            }

            if ($productId == $order['productIdInDB']) {
                $order['productName'] = smp_lookup("product_name", $this->config->item('tbl_products'), "product_id = " . $productId);
                $add_grp = smp_lookup("add_grp", $this->config->item('tbl_products'), "product_id = " . $productId);
                $remove_grp = smp_lookup("remove_grp", $this->config->item('tbl_products'), "product_id = " . $productId);
                $order['productReturnURL'] = smp_lookup("return_url", $this->config->item('tbl_products'), "product_id = "  . $productId);
                $order['productDuration'] = smp_lookup("expire_download", $this->config->item('tbl_products'), "product_id = " . $productId);
                //$kunaki_enabled = smp_lookup("kunaki_enabled", $this->config->item('tbl_products'), "product_id = " . $productId);
                //$kunaki_product_id = smp_lookup("kunaki_product_id", $this->config->item('tbl_products'), "product_id = "  . $productId);
                //$account_id = smp_lookup("account_id", $this->config->item('tbl_products'), "product_id = " . $productId);
                $order['autoresponder_unit'] = smp_lookup("autoresponder_unit", $this->config->item('tbl_products'), "product_id = " . $productId);
                //$autoresponder_service = EES_LookUp("key_value", "global_keyvalue", "key_id = (select autoresponder_service from shop_products where product_id = " . $db->ToSQL($productId, ccsInteger) .")", $db);
                $order['shop_notify_success'] = smp_lookup("key_value", $this->config->item('tbl_config'), "key_name = 'NOTIFY_SUCCESS'");
                $order['shop_notify_void'] = smp_lookup("key_value", $this->config->item('tbl_config'), "key_name = 'NOTIFY_VOID'");
                $tpl_email_sale_completed = smp_lookup("key_value", $this->config->item('tbl_config'), "key_name = 'TPL_EMAIL_NEW_ORDER_USER'");
                $tpl_email_sale_default = smp_lookup("key_value", $this->config->item('tbl_config'), "key_name = 'TPL_EMAIL_NEW_ORDER_USER'");
                $order['admin_email'] = smp_lookup("key_value", $this->config->item('tbl_config'), "key_name = 'ADMIN_EMAIL'");
                $order['admin_name'] = smp_lookup("key_value", $this->config->item('tbl_config'), "key_name = 'ADMIN_NAME'");

                $productQuantity = 1;
                $order['productBasicPrice'] = smp_lookup("price", $this->config->item('tbl_products'), "product_id = " . $productId);
            }
            else {
                smp_log("[clickbank.php]Product ID Received [" . $productId . "] Doesnt Match With Product ID in DB [" . $order['productIdInDB'] . "]");
                exit;
            }

            $order['productGross'] = ($this->clickbank_lib->ipn_data['corderamount'] / 100);

            $order['txn_id'] = $this->clickbank_lib->ipn_data['ctransreceipt'];

            /* SET THE TRANSACTION CODE BASED ON THE PAYMENT STATUS RECEIVED */
            $order['payment_status'] = strtolower($this->clickbank_lib->ipn_data['ctransaction']);
            //smp_log("[clickbank.php]PAYMENT STATUS: " . $payment_status);

            switch($order['payment_status'])
            {
                    case "RFND":
                    case "CGBK":
                    case "INSF":
                    case "CANCEL-REBILL":
                        $order['trans_status_code'] = 0;
                        $order['payment_status'] = 'refunded';
                    break;

                    case "SALE":
                    case "BILL":
                        $order['trans_status_code'] = 1;
                        $order['payment_status'] = "completed";
                    break;

                    default:
                        $order['trans_status_code'] = 1;
                        $order['payment_status'] = "completed";
                    break;
            }
            //smp_log("[clickbank.php]STATUS CODE: " . $trans_status_code);

            $transStatusChange = "";
            $transUpdateUser = false;
            $flag_transaction_status = "";

            // CHECKING IF IT'S A NEW TRANSACTION OR A TRANSACTION STATUS UPDATE
            $where = "gateway_id = '" . $order['txn_id'] . "'";
            
            if ($oldTransStatus = smp_lookup("transaction_status_details", $this->config->item('tbl_transactions'), $where)) {
                //smp_log("RECEIVED AN OLD TRANSACTION");
                $flag_transaction_status = "OLD";
                if ($oldTransStatus != $order['payment_status']) {
                    $transStatusChange = $order['payment_status'];

                    $this->db->where($where);
                    $field_array['transaction_status_details'] = $order['payment_status'];
                    $field_array['transaction_status_code'] = $order['trans_status_code'];
                    $this->db->update($this->config->item('tbl_transactions'), $field_array);
                    $flag_transaction_status = "OLDBUTUPDATE";
                }
            }
            else {
                $flag_transaction_status = "NEW";
                //smp_log("RECEIVED A NEW TRANSACTION");
            }

            if ($flag_transaction_status == "NEW"){
                //smp_log("PROCESSING NEW RECORD");
                // CREATE NEW TRANSACTION RECORD
                if ($order['productDuration'] == 0){
                    $order['productDuration'] = 999;
                }
                //EES_AddToLog("PRODUCT DURATION: " . $productDuration);
                $order['expire_date'] = smp_add_days_to_date(smp_datetime(),$order['productDuration']);
                //EES_AddToLog("EXPIRY DATE FORMED: " . $collector_variable_expire_date);
                $field_array_transaction['transaction_date'] = smp_datetime();
                $field_array_transaction['begin_date'] = smp_datetime();
                $field_array_transaction['expire_date'] = $order['expire_date'];
                $field_array_transaction['transaction_memo'] = $this->clickbank_lib->ipn_data['ctid'];
                $field_array_transaction['currency_code'] = $this->clickbank_lib->ipn_data['ccurrency'];
                $field_array_transaction['transaction_amount'] = $order['productGross'];
                $field_array_transaction['user_id'] = $order['user_id'];
                $field_array_transaction['gateway_id'] = $order['txn_id'];
                $field_array_transaction['transaction_status_details'] = $order['payment_status'];
                $field_array_transaction['transaction_type'] = 1;
                $field_array_transaction['transaction_category'] = 1;
                $field_array_transaction['transaction_title'] = $order['productName'];
                $field_array_transaction['transaction_status_code'] = $order['trans_status_code'];
                $field_array_transaction['channel'] = $channel;
                $this->db->insert($this->config->item('tbl_transactions'), $field_array_transaction);

                //smp_log("CLICKBANK TRANSACTION ID: " . $txn_id);
                $orderId = smp_lookup("transaction_id", $this->config->item('tbl_transactions'), "gateway_id = '" . $order['txn_id'] . "'");
                //smp_log("LATEST TRANSACTION ID: " . $orderId);

                //smp_log("Inserting in Shop Order Items");
                $field_array_orderitems['quantity'] = $productQuantity;
                $field_array_orderitems['price'] = $order['productGross'];
                $field_array_orderitems['order_id'] = $orderId;
                $field_array_orderitems['product_id'] = $productId;
                $this->db->insert($this->config->item('tbl_order_items'), $field_array_orderitems);
                //smp_log("Inserted in Shop Order Items");


                /* UPDATING USER GROUP IF SET IN PRODUCT CONFIGURATION */
                if ($add_grp > 0){
                    if ($remove_grp) {
                        $remove_grp = $remove_grp;
                    }
                    else {
                        $changeback_grp = 0;
                    }
                    if ($order['trans_status_code'] == 1){
                        $field_array_users['role_id'] = $add_grp;
                    }
                    if ($order['trans_status_code'] == 0 && $remove_grp > 0){
                        $field_array_users['role_id'] = $remove_grp;
                    }
                    $where = "user_id = " . $order['user_id'];
                    $this->db->update($this->config->item('tbl_users'), $field_array_users, $where);
                    //smp_log("UPDATED USER GROUP");
                }



                /* ADDING CUSTOMER TO AUTORESPONDER, IF SPECIFIED */
                if ($order['autoresponder_unit'] <> ""){
                    //smp_log("ADDING CUSTOMER TO AR");
                    // load email lib and email results

                    $data['subject'] = '[SUBSCRIBE]';
                    $data['message'] = '[SUBSCRIBE]';
                    $data['from'] = $order['user_email'];
                    $data['name'] = $this->clickbank_lib->ipn_data['ccustfirstname'];
                    $data['to'] = $order['autoresponder_unit'];
                    smp_sendmail($data);
                    smp_log("[clickbank.php]CUSTOMER ADDED TO AR");
                }

                /* FINALLY, NOTIFY CUSTOMER & ADMIN BY EMAIL --- STARTS */
                $emailTpl = "";
                $emailTpl = smp_lookup("key_value", $this->config->item('tbl_config'), "key_name = 'TPL_EMAIL_NEW_ORDER_USER'");
                //smp_log("NOTIFYING CUSTOMER");

                if ($emailTpl<>"")
                {
                    $emailTpl = str_replace("{first_name}", $this->clickbank_lib->ipn_data['ccustfirstname'], $emailTpl);
                    $emailTpl = str_replace("{last_name}", $this->clickbank_lib->ipn_data['ccustlastname'], $emailTpl);
                    $emailTpl = str_replace("{download_link}", $order['productReturnURL'], $emailTpl);
                    $emailTpl = str_replace("{admin_name}", $order['admin_name'], $emailTpl);
                    $emailTpl = str_replace("{item_name}", $order['productName'], $emailTpl);
                    $emailTpl = str_replace("{username}", $order['user_name'], $emailTpl);
                    $emailTpl = str_replace("{password}", $order['user_password'], $emailTpl);

                    $data['subject'] = '[Your Order]:' . $order['productName'];
                    $data['message'] = $emailTpl;
                    $data['from'] = $order['admin_email'];
                    $data['name'] = $order['admin_name'];
                    $data['to'] = $order['user_email'];
                    $data['bcc'] = $order['admin_email'];
                    smp_sendmail($data);
                    smp_log("[clickbank.php]CUSTOMER NOTIFIED BY EMAIL");
                }
                /* FINALLY, NOTIFY CUSTOMER & ADMIN BY EMAIL --- ENDS */

                /* Call after order hooks to process additional functionality */
                smp_hook($this->config->item('hook_shop_order_complete'), $order);


            }



        }
        else {
            smp_log("[clickbank.php]IPN Failed");
        }
    }

}

/* End of file clickbank.php */
/* Location: ./app/controllers/gateways/clickbank.php */