<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Nanacast extends Controller {

    function __construct() {
            parent::Controller();
    }

    function process($apikey = '', $mode = '', $transaction_id = '', $product_price = '', $product_id = '', $user_email = '', $user_first_name = '', $user_last_name = '', $user_ip = '', $source = 'NANACAST')
    {
        smp_log("[nanacast.php] mode:" . $mode);
        smp_log("[nanacast.php] transaction_id:" . $transaction_id);
        smp_log("[nanacast.php] user_email:" . $user_email);
        
        $user_email = str_replace("{u_email}", '', $user_email);
        $user_first_name = str_replace("{u_firstname}", '', $user_first_name);


        if (($transaction_id <> '') && ($product_id > 0) && ($user_email <> '') && ($user_first_name <> '')) {
            if($apikey == smp_lookup("key_value", $this->config->item('tbl_config'), "key_name = 'API_KEY'")) {
                $payment_data['channel'] = $source;
                $payment_data['transaction_id'] = $transaction_id;
                $payment_data['product_id'] = $product_id;
                $payment_data['user_email'] = $user_email;
                $payment_data['user_first_name'] = $user_first_name;
                $payment_data['user_last_name'] = $user_last_name;
                $payment_data['product_price'] = $product_price;
                $payment_data['mode'] = $mode;
                $payment_data['user_ip'] = $user_ip;

                $this->_process($payment_data);
            }
            else {
                smp_log("[nanacast.php] Fraud Attempt To Record And Order With Email Address: " . $user_email);
            }
        }
        else {
            smp_log("[nanacast.php] Order Attempt To Record Order With No Details");
        }
    }


    function _process($payment_data)
    {
        if($payment_data['mode'] == 'add' || $payment_data['mode'] == 'payment'){
            $productId = $payment_data['product_id'];
            $order['product_id'] = $productId;
            $order['productIdInDB'] = smp_lookUp("product_id", $this->config->item('tbl_products'), "product_id = " . $productId);
            $order['user_id'] = smp_lookUp("user_id", $this->config->item('tbl_users'), "email = '" . $payment_data['user_email'] . "' OR username = '" . $payment_data['user_email'] . "'");
            if ($order['user_id'] == "" || $order['user_id'] < 1){
                // Create new user account
                $field_array['first_name'] = $payment_data['user_first_name'];
                $field_array['last_name'] = $payment_data['user_last_name'];
                $field_array['email'] = $payment_data['user_email'];
                $field_array['username'] = $payment_data['user_email'];
                $field_array['password'] = smp_getrandstring(8);
                $field_array['role_id'] = 2;
                $field_array['r_cre_time'] = smp_datetime();
                $field_array['r_mod_time'] = smp_datetime();
                $field_array['remote_addr'] = $payment_data['user_ip'];
                $field_array['last_ip'] = $payment_data['user_ip'];
                $this->db->insert($this->config->item('tbl_users'), $field_array);
                $user_id = $this->db->insert_id();
            }

            $order['user_name'] = smp_lookUp("username", $this->config->item('tbl_users'), "user_id = " . $order['user_id']);
            $order['user_password'] = smp_lookUp("password", $this->config->item('tbl_users'), "user_id = " . $order['user_id']);
            $order['user_email'] = smp_lookup("email", $this->config->item('tbl_users'), "user_id = " . $order['user_id']);
            $order['user_first_name'] = smp_lookup("first_name", $this->config->item('tbl_users'), "user_id = " . $order['user_id']);
            $user_last_name = smp_lookup("last_name", $this->config->item('tbl_users'), "user_id = " . $user_id);


            if ($productId == $order['productIdInDB']) {
                $order['productName'] = smp_lookup("product_name", $this->config->item('tbl_products'), "product_id = " . $productId);
                $order['currency_code'] = smp_lookup("currency_code", $this->config->item('tbl_products'), "product_id = " . $productId);
                $add_grp = smp_lookup("add_grp", $this->config->item('tbl_products'), "product_id = " . $productId);
                $remove_grp = smp_lookup("remove_grp", $this->config->item('tbl_products'), "product_id = " . $productId);
                $order['productReturnURL'] = smp_lookup("return_url", $this->config->item('tbl_products'), "product_id = "  . $productId);
                $order['productDuration'] = smp_lookup("expire_download", $this->config->item('tbl_products'), "product_id = " . $productId);
                $order['autoresponder_unit'] = smp_lookup("autoresponder_unit", $this->config->item('tbl_products'), "product_id = " . $productId);
                $order['shop_notify_success'] = smp_lookup("key_value", $this->config->item('tbl_config'), "key_name = 'NOTIFY_SUCCESS'");
                $order['shop_notify_void'] = smp_lookup("key_value", $this->config->item('tbl_config'), "key_name = 'NOTIFY_VOID'");
                $tpl_email_sale_completed = smp_lookup("key_value", $this->config->item('tbl_config'), "key_name = 'TPL_EMAIL_NEW_ORDER_USER'");
                $tpl_email_sale_default = smp_lookup("key_value", $this->config->item('tbl_config'), "key_name = 'TPL_EMAIL_NEW_ORDER_USER'");
                $order['admin_email'] = smp_lookup("key_value", $this->config->item('tbl_config'), "key_name = 'ADMIN_EMAIL'");
                $order['admin_name'] = smp_lookup("key_value", $this->config->item('tbl_config'), "key_name = 'ADMIN_NAME'");

                $productQuantity = 1;
                $order['productBasicPrice'] = smp_lookup("price", $this->config->item('tbl_products'), "product_id = " . $productId);
            }
            else {
                smp_log("[nanacast.php]Product ID Received [" . $productId . "] Doesnt Match With Product ID in DB [" . $order['productIdInDB'] . "]");
                exit;
            }

            if (isset($payment_data['product_price'])) {
                $order['productGross'] = $payment_data['product_price'];
            }
            else {
                $order['productGross'] = smp_lookup("price", $this->config->item('tbl_products'), "product_id = " . $productId);
            }

            $order['txn_id'] = $payment_data['transaction_id'];
            if(!$order['txn_id']){
                $order['txn_id'] = strtoupper($payment_data['channel'] . '#' . smp_getrandstring(10));
            }
            else{
                $order['txn_id'] = strtoupper($payment_data['channel'] . $order['txn_id']);
            }

            /* SET THE TRANSACTION CODE BASED ON THE PAYMENT STATUS RECEIVED */
            $order['payment_status'] = strtolower('completed');
            $order['trans_status_code'] = 1;
            $transStatusChange = "";
            $transUpdateUser = false;
            $flag_transaction_status = "";

            $flag_transaction_status = "NEW";
            if ($flag_transaction_status == "NEW"){
                // CREATE NEW TRANSACTION RECORD
                if ($order['productDuration'] == 0){
                    $order['productDuration'] = 999;
                }
                $order['expire_date'] = smp_add_days_to_date(smp_datetime(),$order['productDuration']);
                $field_array_transaction['transaction_date'] = smp_datetime();
                $field_array_transaction['begin_date'] = smp_datetime();
                $field_array_transaction['expire_date'] = $order['expire_date'];
                $field_array_transaction['transaction_memo'] = $order['user_id'];
                $field_array_transaction['currency_code'] = $order['currency_code'];
                $field_array_transaction['transaction_amount'] = $order['productGross'];
                $field_array_transaction['user_id'] = $order['user_id'];
                $field_array_transaction['gateway_id'] = $order['txn_id'];
                $field_array_transaction['transaction_status_details'] = $order['payment_status'];
                $field_array_transaction['transaction_type'] = 1;
                $field_array_transaction['transaction_category'] = 1;
                $field_array_transaction['transaction_title'] = $order['productName'];
                $field_array_transaction['transaction_status_code'] = $order['trans_status_code'];
                $field_array_transaction['channel'] = $payment_data['channel'];
                $this->db->insert($this->config->item('tbl_transactions'), $field_array_transaction);

                //smp_log("PAYPAL TRANSACTION ID: " . $txn_id);
                $orderId = $this->db->insert_id();
                //smp_log("LATEST TRANSACTION ID: " . $orderId);

                //smp_log("Inserting in Shop Order Items");
                $field_array_orderitems['quantity'] = $productQuantity;
                $field_array_orderitems['price'] = $order['productGross'];
                $field_array_orderitems['order_id'] = $orderId;
                $field_array_orderitems['product_id'] = $productId;
                $this->db->insert($this->config->item('tbl_order_items'), $field_array_orderitems);
                //smp_log("Inserted in Shop Order Items");


                /* UPDATING USER GROUP IF SET IN PRODUCT CONFIGURATION */
                if ($add_grp > 0){
                    if ($remove_grp) {
                        $remove_grp = $remove_grp;
                    }
                    else {
                        $changeback_grp = 0;
                    }
                    if ($order['trans_status_code'] == 1){
                        $field_array_users['role_id'] = $add_grp;
                    }
                    if ($order['trans_status_code'] == 0 && $remove_grp > 0){
                        $field_array_users['role_id'] = $remove_grp;
                    }
                    $where = "user_id = " . $order['user_id'];
                    $this->db->update($this->config->item('tbl_users'), $field_array_users);
                    //smp_log("UPDATED USER GROUP");
                }



                /* ADDING CUSTOMER TO AUTORESPONDER, IF SPECIFIED */
                if ($order['autoresponder_unit'] <> ""){
                    //smp_log("ADDING CUSTOMER TO AR");
                    // load email lib and email results
                    $data['subject'] = '[SUBSCRIBE]';
                    $data['message'] = '[SUBSCRIBE]';
                    $data['from'] = $order['user_email'];
                    $data['name'] = $order['user_first_name'];
                    $data['to'] = $order['autoresponder_unit'];
                    smp_sendmail($data);
                    smp_log("[nanacast.php]CUSTOMER ADDED TO AR");
                }

                /* FINALLY, NOTIFY CUSTOMER & ADMIN BY EMAIL --- STARTS */
                $emailTpl = "";
                $emailTpl = smp_lookup("key_value", $this->config->item('tbl_config'), "key_name = 'TPL_EMAIL_NEW_ORDER_USER'");
                //smp_log("NOTIFYING CUSTOMER");

                if ($emailTpl<>"")
                {
                    $emailTpl = str_replace("{first_name}", $order['user_first_name'], $emailTpl);
                    $emailTpl = str_replace("{last_name}", $order['user_last_name'], $emailTpl);
                    $emailTpl = str_replace("{download_link}", $order['productReturnURL'], $emailTpl);
                    $emailTpl = str_replace("{admin_name}", $order['admin_name'], $emailTpl);
                    $emailTpl = str_replace("{item_name}", $order['productName'], $emailTpl);
                    $emailTpl = str_replace("{username}", $order['user_name'], $emailTpl);
                    $emailTpl = str_replace("{password}", $order['user_password'], $emailTpl);

                    $data['subject'] = '[Your Order]:' . $order['productName'];
                    $data['message'] = $emailTpl;
                    $data['from'] = $order['admin_email'];
                    $data['name'] = $order['admin_name'];
                    $data['to'] = $order['user_email'];
                    $data['bcc'] = $order['admin_email'];
                    smp_sendmail($data);
                    smp_log("[nanacast.php]CUSTOMER NOTIFIED BY EMAIL");
                }
                /* FINALLY, NOTIFY CUSTOMER & ADMIN BY EMAIL --- ENDS */

                /* Call after order hooks to process additional functionality */
                smp_hook($this->config->item('hook_shop_order_complete'), $order);

            }

            if ($order['productReturnURL']){
                header('Location: ' . $order['productReturnURL']);
            }
            else {
                echo "This product is added to your purchases. Please access customer area to access the product.";
            }



        }
    }

}

/* End of file nanacast.php */
/* Location: ./app/controllers/gateways/nanacast.php */