<?php if (!defined('BASEPATH')) exit('No direct script access allowed');

/**
 * PayPal_Lib Controller Class (Paypal IPN Class)
 *
 * @package     CodeIgniter
 * @subpackage  Libraries
 * @category    Commerce
 * @author      Ran Aroussi <ran@aroussi.com>
 * @copyright   Copyright (c) 2006, http://aroussi.com/ci/
 * @modified by Deep Arora, for SiteManPro Software
 *
 */

class Paypal_Lib {

    var $last_error;			// holds the last error encountered
    var $ipn_log;			// bool: log IPN results to text file?

    var $ipn_log_file;			// filename of the IPN log
    var $ipn_response;			// holds the IPN response from paypal
    var $ipn_data = array();            // array contains the POST values for IPN
    var $fields = array();		// array holds the fields to submit to paypal

    var $submit_btn = '';		// Image/Form button
    var $button_path = '';		// The path of the buttons

    var $CI;

    function Paypal_Lib()
    {
        $this->CI =& get_instance();
        $this->CI->load->helper('url');
        $this->CI->load->helper('form');

        $this->paypal_url = 'https://www.paypal.com/cgi-bin/webscr';

        $this->last_error = '';
        $this->ipn_response = '';

        //$this->ipn_log_file = $this->CI->config->item('paypal_lib_ipn_log_file');
        //$this->ipn_log = $this->CI->config->item('paypal_lib_ipn_log');
        //$this->button_path = $this->CI->config->item('paypal_lib_button_path');
        //$this->add_field('cmd','_xclick');
        //$this->add_field('currency_code', $this->CI->config->item('paypal_lib_currency_code'));
        //$this->add_field('quantity', '1');

        $this->add_field('rm','2'); // Return method = POST
        $this->button('Pay Now!');
    }

    function button($value)
    {
        // changes the default caption of the submit button
        $this->submit_btn = form_submit('pp_submit', $value);
    }

    function image($file)
    {
        $this->submit_btn = '<input type="image" name="add" src="' . site_url($this->button_path .'/'. $file) . '" border="0" />';
    }


    function add_field($field, $value)
    {
        // adds a key=>value pair to the fields array, which is what will be
        // sent to paypal as POST variables.  If the value is already in the
        // array, it will be overwritten.
        $this->fields[$field] = $value;
    }

    function paypal_auto_form()
    {
        // this function actually generates an entire HTML page consisting of
        // a form with hidden elements which is submitted to paypal via the
        // BODY element's onLoad attribute.  We do this so that you can validate
        // any POST vars from you custom form before submitting to paypal.  So
        // basically, you'll have your own form which is submitted to your script
        // to validate the data, which in turn calls this function to create
        // another hidden form and submit to paypal.

        $this->button('Click here if you\'re not automatically redirected...');

        echo '<html>' . "\n";
        echo '<head><title>Processing Payment...</title></head>' . "\n";
        echo '<body onLoad="document.forms[\'paypal_auto_form\'].submit();">' . "\n";
        echo '<center><p><font style=\'font-size:10px; font-family:arial;\'>Please wait, your order is being processed and you will be redirected to the paypal website.</font></p>' . "\n";
        echo $this->paypal_form('paypal_auto_form');
        echo '</center></body></html>';
    }

    function paypal_form($form_name='paypal_form')
    {
        $str = '';
        $str .= '<form method="post" action="'.$this->paypal_url.'" name="'.$form_name.'"/>' . "\n";
        foreach ($this->fields as $name => $value)
                $str .= form_hidden($name, $value) . "\n";
        $str .= '<p>'. $this->submit_btn . '</p>';
        $str .= form_close() . "\n";

        return $str;
    }

    function validate_ipn()
    {
        // PayPal now provides a variable called test_ipn on sandbox IPN's for simple flagging of sandbox IPN vs. production IPN
        $sandbox = false;
        if (smp_getfrompost("test_ipn")){
            $sandbox = true;
        }
        $ssl = $sandbox ? false : true;
        $ppHost = $sandbox ? 'www.sandbox.paypal.com' : 'www.paypal.com';
        //smp_log("Inside Vaildate IPN");
        //smp_log("TXN_ID GFP:" . smp_getfrompost("txn_id"));
        //smp_log("TXN_ID GFG:" . smp_getfromget("txn_id"));

        $isPDT = strlen(smp_getfromget("tx"));
        if (smp_getfrompost("txn_id")<>""){
                $isIPN = strlen(smp_getfrompost("txn_id"));
        }
        else{
                $isIPN = strlen(smp_getfrompost("subscr_id"));
        }
        $isReturn = strlen(smp_getfromget("txn_id"));
        $pp_verified = false;

        //smp_log("PP Verified:" . $pp_verified);

        if ($isPDT || $isIPN) {
            //smp_log("Inside isPDT or isIPN");

            $request = "";
            if ($isPDT) {
                $request = "cmd=_notify-synch&tx=" . smp_getfromget("tx") . "&at=";
                $header = '';
                $header .= "POST /cgi-bin/webscr HTTP/1.0\r\n";
                $header .= "Content-Type: application/x-www-form-urlencoded\r\n";
                $header .= "Content-Length: " . strlen($request) . "\r\n\r\n";
                $fp = fsockopen($ppHost, 80, $errno, $errstr, 30);
            }
            if ($isIPN) {

                // Read the post from PayPal and add 'cmd'
  
                $request = 'cmd=_notify-validate';
                if(function_exists('get_magic_quotes_gpc')) {
                    $get_magic_quotes_exits = true;
                }
                foreach ($_POST as $key => $value)
                {
                  // Handle escape characters, which depends on setting of magic quotes
                  if($get_magic_quotes_exists == true && get_magic_quotes_gpc() == 1) {
                        $value = urlencode(stripslashes($value));
                  } else {
                        $value = urlencode($value);
                  }

                /* FOR HANDLING A SITUATION
                  When the Street Address 1 and 2 are concatenated in Paypal :
                  - For the carriage return, Paypal insert a %0D%0A between address1 and address2
                  - For the carriage return, in my code (PHP Version 5.2.10), urlencode() uses only %0A
                  So, the strings don't match and PAYPAL return an INVALID confirmation
                 */

                  $value = preg_replace('/(.*[^%^0^D])(%0A)(.*)/i','${1}%0D%0A${3}',$value);
                  $request .= "&$key=$value";
                }
                smp_log("request notify validate:" . $request);
                //smp_log($_POST);

                
                //$request = "cmd=_notify-validate&" . smp_getquerystring("Form", "");
                //$header = '';
                $header .= "POST /cgi-bin/webscr HTTP/1.0\r\n";
                $header .= "Content-Type: application/x-www-form-urlencoded\r\n";
                $header .= "Content-Length: " . strlen($request) . "\r\n\r\n";
                $fp = fsockopen($ppHost, 80, $errno, $errstr, 15);
                //$fp = fsockopen($ppHost, 443, $errno, $errstr, 30);
            }

            //smp_log("FP1:". $fp);

            if ($fp) {
                //smp_log("FP2:". $fp);

                fputs($fp, $header . $request);
                $result = "";
                if ($isPDT) {
                    $headerDone = false;
                    while (!feof($fp)) {
                        $line = fgets ($fp, 1024);
                        if (strcmp($line, "\r\n") == 0) {
                            $headerDone = true;
                        }
                        else if ($headerDone) {
                            $result .= $line;
                        }
                    }
                    //smp_log("RESULT PDT:" . $result);

                    $lines = explode("\n", $result);
                    if (strcmp ($lines[0], "SUCCESS") == 0) {
                        $pp_verified = true;
                        for ($i = 1; $i < count($lines); $i++){
                            list($key, $val) = explode("=", $lines[$i]);
                            //$var_name = "pp_" . urldecode($key);
                            $var_name = urldecode($key);
                            $this->ipn_data[$var_name] = urldecode($val);
                            //smp_log("IPNData:" . $var_name . ":" . $this->ipn_data[$var_name]);
                        }
                    }
                    else {
                        smp_log("FAILED to verify PDT request.");
                    }
                }
                else {
                    //smp_log("Its IPN");
                    while (!feof($fp)) {
                        //smp_log("inside while loop of ipn");
                        $result = fgets ($fp, 1024);
                        //smp_log("RESULT-IPN: " . $result);
                        if (strcmp ($result, "VERIFIED") == 0) {
                            foreach($_POST as $paramKey => $paramValue) {
                                //$var_name = "pp_" . $paramKey;
                                $var_name = $paramKey;
                                $this->ipn_data[$var_name] = smp_getfrompost($paramKey);
                                smp_log("IPNData:" . $var_name . ":" . $this->ipn_data[$var_name]);
                            }
                            $pp_verified = true;
                        }
                    }
                    if (!$pp_verified) {
                        smp_log("INVALID IPN request received");
                    }
                }
                fclose($fp);
            }
        }
        //smp_log("returning Verfied Status As:" . $pp_verified);
        return $pp_verified;
    }

    function log_ipn_results($success)
    {
        if (!$this->ipn_log) return;  // is logging turned off?

        // Timestamp
        $text = '['.date('m/d/Y g:i A').'] - ';

        // Success or failure being logged?
        if ($success) $text .= "SUCCESS!\n";
        else $text .= 'FAIL: '.$this->last_error."\n";

        // Log the POST variables
        $text .= "IPN POST Vars from Paypal:\n";
        foreach ($this->ipn_data as $key=>$value)
                $text .= "$key=$value, ";

        // Log the response from the paypal server
        $text .= "\nIPN Response from Paypal Server:\n ".$this->ipn_response;

        // Write to log
        $fp=fopen($this->ipn_log_file,'a');
        fwrite($fp, $text . "\n\n");

        fclose($fp);  // close file
    }


    function dump()
    {
        // Used for debugging, this function will output all the field/value pairs
        // that are currently defined in the instance of the class using the
        // add_field() function.

        ksort($this->fields);
        echo '<h2>ppal->dump() Output:</h2>' . "\n";
        echo '<code style="font: 12px Monaco, \'Courier New\', Verdana, Sans-serif;  background: #f9f9f9; border: 1px solid #D0D0D0; color: #002166; display: block; margin: 14px 0; padding: 12px 10px;">' . "\n";
        foreach ($this->fields as $key => $value) echo '<strong>'. $key .'</strong>:	'. urldecode($value) .'<br/>';
        echo "</code>\n";
    }

}

?>