<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Action extends Controller {

	function __construct() {
		parent::Controller();
		$this->load->model($this->config->item('user_model'));
  	}

	//---------------------------------------------------------------
	
	/**
	 * Function: index
	 * Description: Shows the user logon page
	 * ##############################################################
	 * Written: 01/17/2010
	 * Author: Deep Arora
	 * --------------------------------------------------------------
	 * Update Log:
	 * --------------------------------------------------------------	 
	 * ##############################################################	 
	 * @access public
	 * @return void
	 */	
	function index($offset = '')
	{
            if ($this->session->userdata('role_id') == 1){
                $welcome_page = site_url($this->config->item('welcome_page'));
                header('Location: ' . $welcome_page);
            }
            
            /* Create FORM */
            $var_login_form_open = "global/action/dologin/";
            $var_login_form_attributes = array('id' => 'user_login_form');
            $login_form_open = form_open($var_login_form_open, $var_login_form_attributes);
            $form_close = "</form>";

            $var_forget_form_open = "global/action/forget/";
            $forget_form_open = form_open($var_forget_form_open);

            
            $this->template->set('login_form_open', $login_form_open);
            $this->template->set('forget_form_open', $forget_form_open);
            $this->template->set('form_close', $form_close);
            
            //$this->template->use_ci_parser = TRUE;

            // Load the template
            //$this->template->current_view = $this->config->item('login_view');
            //$this->template->render($this->config->item('layout_folder') . 'login');

            $this->template->view($this->config->item('login_view'), 'login');

	}
	
	//---------------------------------------------------------------
	
	/**
	 * Function: dologin
	 * Description: Logon the user
	 * ##############################################################
	 * Written: 01/17/2010
	 * Author: Deep Arora
	 * --------------------------------------------------------------
	 * Update Log:
	 * --------------------------------------------------------------	 
	 * ##############################################################	 
	 * @access public
	 * @return void
	 */	
	
	function dologin()
	{
            $this->form_validation->set_rules('user_name', 'Username', 'required');
            $this->form_validation->set_rules('user_password', 'Password', 'required');

            if ($this->form_validation->run() == FALSE)
            {
                //$data = array('result' => $this->lang->line('error_missing_fields'));
                $this->session->set_flashdata('error',  $this->lang->line('error_invalid_login'));
                $login_page = site_url("global/action");
                header('Location: ' . $login_page);
                //echo json_encode($data);
            }
            else
            {
                $this->User_model->dologin($this->input->post('user_name'), $this->input->post('user_password'));
                if ($this->session->userdata('user_id') <> '')
                {
                    //$data = array('result' => 'login-success');
                    //echo json_encode($data);
                    //echo $this->config->item('welcome_page');
                    if ($this->session->userdata('role_id') == 1){
                        $app_version = smp_lookup('key_value', $this->config->item('tbl_config'), 'key_name = \'VERSION\'');
                        if (($app_version >= 1.14)){
                            $welcome_page = site_url('global/dashboard');
                        }
                        else{
                            $welcome_page = site_url($this->config->item('welcome_page'));
                        }
                    }
                    else if ($this->session->userdata('role_id') == 2){
                        $welcome_page = site_url($this->config->item('customer_page'));
                    }
                    else{
                        $welcome_page = site_url("global/action");
                    }
                    header('Location: ' . $welcome_page);
                }
                else
                {
                    //$data = array('result' => $this->lang->line('error_invalid_login'));
                    $this->session->set_flashdata('error',  $this->lang->line('error_invalid_login'));
                    $login_page = site_url("global/action");
                    header('Location: ' . $login_page);
                    //echo json_encode($data);
                }
            }
	}

	//---------------------------------------------------------------

	/**
	 * Function: dologout
	 * Description: Logout the user
	 * ##############################################################
	 * Written: 01/17/2010
	 * Author: Deep Arora
	 * --------------------------------------------------------------
	 * Update Log:
	 * --------------------------------------------------------------
	 * ##############################################################
	 * @access public
	 * @return void
	 */

	function dologout()
	{
            $user_data = array
                        (
                        'user_id' => '',
                        'user_name' => '',
                        'role_id' => '',
                        'first_name' => '',
                        'last_name' => '',
                        'email' => '',
                        'doj' => '',
                        'logged_in' => FALSE
                        );
            $this->session->unset_userdata($user_data);
            $login_page = site_url("global/action");
            header('Location: ' . $login_page);
	}

        //---------------------------------------------------------------


	/**
	 * Function: forget
	 * Description: Retrieve the user's password
	 * ##############################################################
	 * Written: 01/17/2010
	 * Author: Deep Arora
	 * --------------------------------------------------------------
	 * Update Log:
	 * --------------------------------------------------------------
	 * ##############################################################
	 * @access public
	 * @return void
	 */

	function forget()
	{
            $this->form_validation->set_rules('email', 'Email', 'required');

            if ($this->form_validation->run() == FALSE)
            {
                $this->session->set_flashdata('error',  $this->lang->line('error_missing_email'));
                $login_page = site_url("global/action#tabs-3");
                header('Location: ' . $login_page);

            }
            else
            {
                $send_paddword_status = $this->User_model->send_password($this->input->post('email'));
                if ($send_paddword_status == 1)
                {
                    $this->session->set_flashdata('error',  $this->lang->line('message_password_sent'));
                    $login_page = site_url("global/action#tabs-3");
                    header('Location: ' . $login_page);
                }
                else
                {
                    $this->session->set_flashdata('error',  $this->lang->line('error_invalid_email'));
                    $login_page = site_url("global/action#tabs-3");
                    header('Location: ' . $login_page);
                }
            }
	}

	//---------------------------------------------------------------

	/**
	 * Function: noaccess
	 * Description: Shows the noaccess page
	 * ##############################################################
	 * Written: 01/17/2010
	 * Author: Deep Arora
	 * --------------------------------------------------------------
	 * Update Log:
	 * --------------------------------------------------------------
	 * ##############################################################
	 * @access public
	 * @return void
	 */
	function noaccess()
	{
            // Load the template
            //<editor-fold desc="LOAD THE ERROR TEMPLATE">
            $this->template->set('message', $this->lang->line('error_noaccess'));
            $this->template->view($this->config->item('noaccess_view'), 'plain');
            //</editor-fold>
	}

         /**
         * Function: switchtheme
         * Description: Switch the active admin theme
         * ##############################################################
         * Written: 05/01/2010
         * Author: Deep Arora
         * --------------------------------------------------------------
         * Update Log:
         * --------------------------------------------------------------
         * ##############################################################
         * @access public
         * @return void
         */
        function switchtheme($theme = '', $post_action_path = '')
        {
            //<editor-fold desc="SWITCH THEME">
            if (smp_check_session()){
                $field_array['active_theme'] = $theme;
                smp_process_data($field_array, $this->config->item('tbl_users'), 'user_id = ' . $this->session->userdata('user_id'), '', 'Save', false);
            }
            //</editor-fold>
        }
}

/* End of file action.php */
/* Location: ./app/controllers/global/action.php */