<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Perm_model extends Model {

    function Perm_model()
    {
            parent::Model();
    }

    //---------------------------------------------------------------

    /**
     * Function: get_modules
     * Description: Get modules based on user role_id
     * ##############################################################
     * Written: 01/26/2010
     * Author: Deep Arora
     * --------------------------------------------------------------
     * Update Log:
     * --------------------------------------------------------------
     * ##############################################################
     * @access public
     * @return void
     */
    function get_modules() {
        if (!$this->session->userdata('role_id')){
            $role_id = 2;
        }
        else {
            $role_id = $this->session->userdata('role_id');
        }
        
        $this->db->select('*');
        $this->db->from($this->config->item('tbl_modules'));
        $where_additional = "module_id IN (select module_id from ". $this->config->item('tbl_role_modules') ." where perm_view = 1 AND role_id = " . $role_id . ")";
        $this->db->where($where_additional);
        $this->db->where('flg_enable', 'Y');
        $this->db->order_by('ordering', 'ASC');

        $query = $this->db->get();

        if ($query->num_rows() > 0)
        {
                $result = $query->result();
                return $result;
        }
        return 0;
    }
    //---------------------------------------------------------------

     /**
     * Function: get_submodules
     * Description: Get sub modules based on module
     * ##############################################################
     * Written: 01/26/2010
     * Author: Deep Arora
     * --------------------------------------------------------------
     * Update Log:
     * --------------------------------------------------------------
     * ##############################################################
     * @access public
     * @return void
     */
    function get_submodules($module_id = 0) {
        $this->db->select('global_submodule_files.*, global_submodules.*');
        $this->db->from('global_submodule_files, global_submodules');
        $where_additional = "global_submodule_files.submodule_id IN (select submodule_id from ". $this->config->item('tbl_role_modules') ." where perm_view = 1 AND role_id = " . $this->session->userdata('role_id') . " AND module_id = " . $module_id . ") AND global_submodule_files.submodule_id = global_submodules.submodule_id AND global_submodules.flg_enable = 'Y' GROUP BY global_submodule_files.submodule_id";
        $this->db->where($where_additional);
        $this->db->order_by('global_submodules.ordering', 'ASC');

        $query = $this->db->get();

        if ($query->num_rows() > 0)
        {
            $result = $query->result();
            return $result;
        }
        return 0;
    }

    //---------------------------------------------------------------

     /**
     * Function: get_permission
     * Description: Get permission for page for logged in user
     * ##############################################################
     * Written: 02/07/2010
     * Author: Deep Arora
     * --------------------------------------------------------------
     * Update Log:
     * --------------------------------------------------------------
     * ##############################################################
     * @access public
     * @return void
     */
    function get_permission($module_title = '', $submodule_title = '', $action = '') {
        $perm_array[] = "";
        $permission = 0;
        $this->db->select('submodule_id');
        $this->db->from('global_submodule_files');
        $this->db->where('folder_name', $module_title);
        $this->db->where('file_name', $submodule_title);
        $this->db->limit(1);

        $query = $this->db->get();

        if ($query->num_rows() > 0)
        {
            foreach ($query->result() as $row){
                if ($action){
                    $permission = $this->_get_permission_action($row->submodule_id, $action);
                    return $permission;
                }
                else{
                    $perm_array = $this->_get_permission_array($row->submodule_id);
                    return $perm_array;
                }
            }
        }
        return NULL;
    }

    //---------------------------------------------------------------

     /**
     * Function: get_permission_array
     * Description: Get permission array for page for logged in user
     * ##############################################################
     * Written: 02/07/2010
     * Author: Deep Arora
     * --------------------------------------------------------------
     * Update Log:
     * --------------------------------------------------------------
     * ##############################################################
     * @access private
     * @return void
     */
    function _get_permission_array($submodule_id = 0) {
        $perm_array[] = "";
        $this->db->select('*');
        $this->db->from($this->config->item('tbl_role_modules'));
        $this->db->where('role_id', $this->session->userdata('role_id'));
        $this->db->where('submodule_id', $submodule_id);
        $this->db->limit(1);

        $query = $this->db->get();

        if ($query->num_rows() > 0)
        {
            foreach ($query->result() as $row){
                $perm_array[1] = "view";
                $perm_array[2] = $row->perm_view;
                $perm_array[3] = "add";
                $perm_array[4] = $row->perm_add;
                $perm_array[5] = "edit";
                $perm_array[6] = $row->perm_edit;
                $perm_array[7] = "delete";
                $perm_array[8] = $row->perm_delete;
                $perm_array[9] = "self";
                $perm_array[10] = $row->perm_approve_self;
                $perm_array[11] = "others";
                $perm_array[12] = $row->perm_approve_others;
            }
        }
        return $perm_array;
    }

    //---------------------------------------------------------------

     /**
     * Function: _get_permission_action
     * Description: Get permission array for page for logged in user
     * ##############################################################
     * Written: 02/07/2010
     * Author: Deep Arora
     * --------------------------------------------------------------
     * Update Log:
     * --------------------------------------------------------------
     * ##############################################################
     * @access private
     * @return void
     */
    function _get_permission_action($submodule_id = 0, $action = '') {
         switch($action) {
            case "perm_view":
                $this->db->select("perm_view AS permission");
            break;
            case "perm_add":
                $this->db->select("perm_add AS permission");
            break;
            case "perm_edit":
                $this->db->select("perm_edit AS permission");
            break;
            case "perm_delete":
                $this->db->select("perm_delete AS permission");
            break;
            case "perm_self":
                $this->db->select("perm_self AS permission");
            break;
            case "perm_others":
                $this->db->select("perm_others AS permission");
            break;
        
            default:
                //echo "Selecting PERM_VIEW";
                //$this->db->select("perm_view AS permission");
            break;
        }
        $this->db->from($this->config->item('tbl_role_modules'));
        $this->db->where('role_id', $this->session->userdata('role_id'));
        $this->db->where('submodule_id', $submodule_id);
        $this->db->limit(1);

        $query = $this->db->get();

        if ($query->num_rows() > 0)
        {
            foreach ($query->result() as $row){
                return $row->permission;
            }
        }
        return 0;
    }
}

?>
